//+------------------------------------------------------------------+
//|                                          kmondivergencepoint.mq4 |
//|                                                   Kelch Monteiro |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Kelch Monteiro"
#property link      "http://www.metaquotes.net"

#property indicator_separate_window
#property indicator_buffers 1
#property indicator_color1 Gold
//---- input parameters
extern int BBPeriod=200;
extern int maperiod=14;
extern int ma2period=14;
//---- buffers
double ExtMapBuffer1[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   IndicatorShortName("kmondivergencepoint ("+BBPeriod+","+maperiod+")");
//---- indicators
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,ExtMapBuffer1);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| kmon                                                         |
//+------------------------------------------------------------------+
int start()
  {
   int i,counted_bars=IndicatorCounted();
//----
   i=Bars-counted_bars-1;
   while(i>=0)
     {
      double highbb = iBands(NULL,0,BBPeriod,2,0,PRICE_LOW,MODE_UPPER,i)/maperiod;
      double lowbb = iBands(NULL,0,BBPeriod,2,0,PRICE_LOW,MODE_LOWER,i)/maperiod;
      double close = Close[i];
      double ma = iMA(NULL,5,maperiod,0,0,0,i);
      double visota = (highbb-lowbb/maperiod); 
      double maprev = iMA(NULL,0,ma2period,0,0,0,i-1);
      double rsi = (ma*ma)+(maprev*maprev)/close-(close-1)*100;
      if(visota==0){visota=1;}
      double pclose = (close-lowbb/maperiod); 
      double enter = pclose/visota*100/rsi;
      ExtMapBuffer1[i]=enter;         
      i--;
     }
//----
   return(0);
  }
//+------------------------------------------------------------------+